<?php
/**
 * Created by PhpStorm.
 * User: yguern
 * Date: 29/09/2017
 * Time: 08:58
 */

namespace Cloud\RDexp\Calculator;


/**
 * Class Calculator
 * @package Cloud\RDexp\Calculator
 */
class Calculator
{

    private $lastResult = null;

    /**
     * @return null
     */
    public function getLastDatabaseStatus()
    {
        return $this->lastResult;
    }


    /**
     * @param float $a first operand
     * @param float $b second operand
     * @param string $probe Debug parameter
     * @param Database $database A storage instance
     * @return int|string
     * @throws CalculatorException
     */
    public function add($a, $b, &$probe = '', Database $database = null)
    {
        if (!is_numeric($a) || !is_numeric($b)) {

            throw new CalculatorException("Adding not real numbers");
        }

        if ($a > 0) {

            if ($b > 0) {

                $probe = '1 1';

            } elseif ($b == 0) {

                $probe = '1 0';

            } elseif ($b < 0) {

                $probe = '1 -1';

            }


        } elseif ($a == 0) {

            if ($b > 0) {

                $probe = '0 1';

            } elseif ($b == 0) {

                $probe = '0 0';

            } elseif ($b < 0) {

                $probe = '0 -1';

            }

        } elseif ($a < 0) {

            if ($b > 0) {

                $probe = '-1 1';

            } elseif ($b == 0) {

                $probe = '-1 0';

            } elseif ($b < 0) {

                $probe = '-1 -1';

            }

        }

        $result = $a + $b;

        if ($database) {

            $this->lastResult = $database->save(array($a, $b), $result);
        }

        return $result;
    }
}