<?php
/**
 * Created by PhpStorm.
 * User: yguern
 * Date: 29/09/2017
 * Time: 13:18
 */

namespace Cloud\RDexp\Calculator;


class Database
{


    /**
     * @var \PDO A PDO instance
     */
    private $pdo;

    public function __construct($dsn)
    {
        $this->pdo = new \PDO($dsn);
    }

    /**
     * Save operation in database
     * @param $operands
     * @param $result
     * @return bool
     */
    public function save($operands, $result) {

        list($a, $b) = $operands;

        $prepared = $this->pdo->prepare("INSERT INTO operations (a, b, result) VALUES (:a, :b, :result)");

        $prepared->bindParam(':a', $a);
        $prepared->bindParam(':b', $b);
        $prepared->bindParam(':result', $result);

        return $prepared->execute();
    }
}